Option Explicit

#include ..\lib\framework_domotics.vbs
#include local-parameters.inc

Sub main
Dim astrWebPageTXT
Dim astrWebPageHTML
Dim astrBuffer
Dim astrNbDv
Dim i, j
Dim atabDv
Dim astrDevices
Dim astrDevice
Dim astrConfig
Dim aintNbDevOut
Dim aboolReturn
Dim astrPARAM1
Dim tabLines
Dim tabValues
Dim astrLink
Dim astrIcon

WriteLog G_FOLDER_NAME, G_SCRIPT_EVT, G_TIV_INF, "Launching " & G_FOLDER_NAME & " script", G_LOG_FILE
If CheckDevices(G_FOLDER_NAME, G_FILE_INI, G_STATUS_EXIST) Then	
	astrDevices 		= hs.GetINISetting("COMMON","DEVICES","", G_FILE_INI)
	astrConfig  		= hs.GetINISetting("COMMON","CONFIG","..\scripts\config\", G_FILE_INI)
	astrLink     		= hs.GetINISetting("COMMON","LINK","", G_FILE_INI)
	astrIcon    		= hs.GetINISetting("COMMON","ICON","", G_FILE_INI)
	atabDv	  			= Split(astrDevices, G_SEP)
	astrNbDv 	  		= UBound(atabDv) 
	astrWebPageTXT	= ""
	astrWebPageHTML	= ""
	aintNbDevOut  	= 0
	
  	astrWebPageHTML = WGetAndCacheWebPage(	hs.GetINISetting("COMMON","URL","",G_FILE_INI), hs.GetINISetting("COMMON","FILE","",G_FILE_INI), True,0 )
	astrWebPageHTML = CleanString(astrWebPageHTML)
	
	'Remplace les caractres spciaux hml par les bons caractres. Devrait intgrer la fonction CleanString du framework
	astrWebPageHTML = Replace(astrWebPageHTML, "é", "")
	astrWebPageHTML = Replace(astrWebPageHTML, "ç", "")
	astrWebPageHTML = Replace(astrWebPageHTML, "ô", "")
	astrWebPageHTML = Replace(astrWebPageHTML, "ê", "")
	astrWebPageHTML = Replace(astrWebPageHTML, "Ç", "")
	astrWebPageHTML = Replace(astrWebPageHTML, "&Eacute", "")
	astrWebPageHTML = Replace(astrWebPageHTML, "è", "")
	astrWebPageHTML = Replace(astrWebPageHTML, "&ccedil;", "")
	astrWebPageHTML = Replace(astrWebPageHTML, "&agrave;", "")
	astrWebPageHTML = Replace(astrWebPageHTML, "&icirc;", "")
	astrWebPageHTML = Replace(astrWebPageHTML, "&euro;", "E")
	astrWebPageHTML = Replace(astrWebPageHTML, "&ecirc;", "")	
	astrWebPageHTML = Replace(astrWebPageHTML, "&Ccedil;", "")
	astrWebPageHTML = Replace(astrWebPageHTML, "&euml;", "")
	astrWebPageHTML = Replace(astrWebPageHTML, "&ocirc;", "")
	astrWebPageHTML = Replace(astrWebPageHTML, "&amp;", "&")
	astrWebPageHTML = Replace(astrWebPageHTML, "&oelig;", "oe")
	astrWebPageHTML = Replace(astrWebPageHTML, "", "")
	astrWebPageHTML = Replace(astrWebPageHTML, "&iuml;", "")
	astrWebPageHTML = Replace(astrWebPageHTML, "&ouml;", "")
	astrWebPageHTML = Replace(astrWebPageHTML, "&ugrave;", "")
	astrWebPageHTML = Replace(astrWebPageHTML, "&ucirc;", "")
	astrWebPageHTML = Replace(astrWebPageHTML, "&uuml;", "")
	
	If 	(instr(astrWebPageTXT,"Page inconnue") > 0) 	 Or _
		  (instr(astrWebPageTXT,"ERROR") > 0) 			     Or _ 
		  (instr(astrWebPageHTML,"ERROR") > 0)			     Or _ 
		  (astrWebPageHTML = "")							           Then
			
		WriteLog G_FOLDER_NAME, G_SCRIPT_EVT, G_TIV_SEV, "Error during the download of the following url " &  hs.GetINISetting("COMMON","URL","",G_FILE_INI), G_LOG_FILE	
	Else
	
	tabvalues = Split(astrWebPageHTML,"<item>")
    	j = 0
	While (j <= Ubound(tabvalues))
		If astrLink Then

			tabvalues(j) =  "<a href='" & extractStringBetweenTwoTags("<link>", "</link>", tabvalues(j)) & "/' target=blank title='" & 			extractStringBetweenTwoTags("<content:encoded><![CDATA[<p>", "</p>]]></content:encoded>", tabvalues(j)) & "'>" & 			left(right(extractStringBetweenTwoTags("<pubDate>", "</pubDate>", tabvalues(j)),13),5) & " - " & extractStringBetweenTwoTags("<title><![CDATA[", 			"]]></title>", tabvalues(j)) & "</a>" 
		        
		Else
				
		End If
			j = j+1
	Wend

	i = 0
  
	While (i <= CInt(astrNbDv))
    		astrDevice = hs.GetINISetting("DEVICE", "HC", "", astrConfig & atabDv(i)) & _ 
                      hs.GetINISetting("DEVICE", "DC", "", astrConfig & atabDv(i))
    		astrPARAM1 = hs.GetINISetting("DEVICE", "PARAM1", "", astrConfig & atabDv(i))	  
    		If (astrPARAM1 = "TF1") Then
			setDevice astrDevice, tabValues(1), "", ""
		ElseIf (astrPARAM1 = "FRANCE2") Then
			setDevice astrDevice, tabValues(3), "", ""
		ElseIf (astrPARAM1 = "FRANCE3") Then
			setDevice astrDevice, tabValues(5), "", ""
		ElseIf (astrPARAM1 = "CANAL") Then
			setDevice astrDevice, tabValues(7), "", ""
		ElseIf (astrPARAM1 = "ARTE") Then
			setDevice astrDevice, tabValues(9), "", ""
		ElseIf (astrPARAM1 = "M6") Then
			setDevice astrDevice, tabValues(11), "", ""
		ElseIf (astrPARAM1 = "FRANCE4") Then
			setDevice astrDevice, tabValues(13), "", ""
		ElseIf (astrPARAM1 = "FRANCE5") Then
			setDevice astrDevice, tabValues(15), "", ""
		ElseIf (astrPARAM1 = "DIRECT8") Then
			setDevice astrDevice, tabValues(17), "", ""
		ElseIf (astrPARAM1 = "W9") Then
			setDevice astrDevice, tabValues(19), "", ""
		ElseIf (astrPARAM1 = "TMC") Then
			setDevice astrDevice, tabValues(21), "", ""
		ElseIf (astrPARAM1 = "NT1") Then
			setDevice astrDevice, tabValues(23), "", ""
		ElseIf (astrPARAM1 = "NRJ12") Then
			setDevice astrDevice, tabValues(25), "", ""
		ElseIf (astrPARAM1 = "LCP") Then
			setDevice astrDevice, tabValues(27), "", ""
		ElseIf (astrPARAM1 = "ITELE") Then
			setDevice astrDevice, tabValues(29), "", ""
		ElseIf (astrPARAM1 = "VIRGIN17") Then
			setDevice astrDevice, tabValues(31), "", ""
		ElseIf (astrPARAM1 = "GULLI") Then
			setDevice astrDevice, tabValues(33), "", ""
		ElseIf (astrPARAM1 = "BFMTV") Then
			setDevice astrDevice, tabValues(35), "", ""
		ElseIf (astrPARAM1 = "FRANCEO") Then
			setDevice astrDevice, tabValues(37), "", ""
		Else
			WriteLog G_FOLDER_NAME, G_SCRIPT_EVT, G_TIV_CRI, "PARAM1 is unknown for " & astrDevice, G_LOG_FILE	
		End if
		i = i+1
	Wend
	End If
Else
	WriteLog G_FOLDER_NAME, G_SCRIPT_EVT, G_TIV_SEV, "Expected Device is unknown !", G_LOG_FILE
End if
WriteLog G_FOLDER_NAME, G_SCRIPT_EVT, G_TIV_INF, "End of the script", G_LOG_FILE
End sub